<?php

//определение класса 

class fleetCommander {
    var 
        $messBase = array(
            0 => array('subj' => 'attack detected', 'text' => 'Mojesh letet nazad :)'),
            1 => array('subj' => 'to attacker', 'text' => 'Poka letish, vsyo vivezu ;)'),
            2 => array('subj' => 'attakeru', 'text' => 'Letish? ;)'),
        );

    var
        //массив кодов форм и груза с подстраховкой по занимаемому топливу
        $dict = array( //formName, speed, cargo, consumption, Long Name
            'ЛИ'    => array('am204', 25000, 50, 20,    'Лёгкий истребитель:'), 
            'ТИ'    => array('am205', 24000, 100, 75,   'Тяжёлый истребитель:'), 
            'КРС'   => array('am206', 36000, 800, 300,  'Крейсер:'), 
            'Л'     => array('am207', 28000, 1500, 500, 'Линкор:'),/*линкор*/
            'КОЛ'   => array('am208', 6000, 7500, 1000, 'Колонизатор:'), 
            'ПЕР'   => array('am209', 4000, 20000, 300, 'Переработчик:'), 
            'ШП'    => array('am210', 200000000, 0 /* так то 5 но их нельзя использовать для погрузки */, 1,  'Шпионский зонд:'), 
            'БМ'    => array('am211', 9600, 500, 1000,  'Бомбардировщик:'), /* бомбер */
            'УН'    => array('am213', 14000, 2000, 1000,'Уничтожитель:'),
            'ЗС'    => array('am214', 280, 1000000, 1,  'Звезда смерти:'), 
            'ЛИНК'  => array('am215', 28000, 750, 250,  'Линейный крейсер:'), /* линейный крейсер*/
            'МТ'    => array('am202', 24000, 5000, 20,  'Малый транспорт:'),
            'БТ'    => array('am203', 15000, 25000, 50, 'Большой транспорт:')
        );
    var $ud = array(); //настройки и данные по планетам
    var $http;
    var $planets = array(); // список планет, которые получили при авторизации
    var $isAlert = false; //общая угроза атаки
    var $sessionCode = ''; //код текущей сессии
    var $currentTime = 0; //текущее время на сервере
    var $ready = false;
    var $oas = array();

    function mailReport($subj, $body) {
        if (!empty($this->ud['report-mail'])) 
            mail($this->ud['report-mail'], $subj, $body);
        $this->logReport($subj, $body);
    }

    function logReport($subj, $body) {
        $this->oas['logs'][] = array(
            'time' => time(), 
            'subj' => $subj,
            'body' => $body);
    }
    
    /* расстояние между двумя планетами */
    function distance($from, $to) {
        list($thisGalaxy, $thisSystem, $thisPlanet) = explode(':', $from);
        list($targetGalaxy, $targetSystem, $targetPlanet) = explode(':', $to);

        $dist = 0;
        if (($targetGalaxy - $thisGalaxy) != 0) {
            $dist = abs($targetGalaxy - $thisGalaxy) * 20000;
        } else if (($targetSystem - $thisSystem) != 0) {
            $dist = abs($targetSystem - $thisSystem) * 5 * 19 + 2700;
        } else if (($targetPlanet - $thisPlanet) != 0) {
            $dist = abs($targetPlanet - $thisPlanet) * 5 + 1000;
        } else {
            $dist = 5;
        }
        return $dist;
    }
    
    /* время полета */
    function getDuration($ships, $speedFactor, $distance) {
        $maxSpeed = 9999999999;
        foreach($ships as $k => $v) {
            $maxSpeed = min($maxSpeed, $this->dict[$k][1]);
        }
        
        if ($speedFactor == 0 || $maxSpeed == 0) return 0;
    
        return round(((35000 / $speedFactor * sqrt($distance * 10 / $maxSpeed) + 10) / 1 ));
    }
    
    /* рассчет суммарной ёмкости флота */
    function calcFreeCargo($ships) {
        $cargo = 0;
        foreach($ships as $k => $v) 
            $cargo += $this->dict[$k][2] * $v;
        return $cargo;
    }
    
    /* потребление топлива при движении - корабли, режим скорости, расстояние */
    function consumption($ships, $speedFactor, $distance) {
        $consumptionCounter = 0;
        $countedShips = 0;

        echo "dur = " . ($duration = $this->getDuration($ships, $speedFactor, $distance)) . ' ';
        
        foreach($ships as $k => $v) {
            $countedShips++;
            $shipSpeedValue = 35000 / ($duration - 10) * sqrt($distance * 10 / $this->dict[$k][1]);

            $consumptionCounter += $this->dict[$k][3] * $distance / 35000 * (($shipSpeedValue / 10) + 1) * (($shipSpeedValue / 10) + 1) * $v;
        }

        if($countedShips>0) {
            return round($consumptionCounter) + 1;
        } else {
            return 0;
        }
    }    
    
    function mail($koords, $subj, $text) {
        //смотрим в галактичесую карту - там можно ссылки найти на отправку сообщения, в которой код юзера есть
        $map = $this->getGalaxyPage($koords);
        //пытаемся выделить код юзера
        if (!preg_match('@&to=([\d]+)&@', $map[$koords]['messageLink'], $m)) return false;
        //отправка собственно самого письма
        $this->http->post("http://{$this->ud['uniUrl']}/game/index.php?page=messages&session={$this->sessionCode}&to=$m[1]",
            "betreff=&" . urlencode($subj) . "text=" . urlencode($text) );
    }
    
    /* Эвакуация согласно данным маршрута атаки */
    function evacuation($koords) { 
        $cp = $this->getCPbyKoords($koords);
        if ($cp) {
            //читаем данные по планете, от куда нужно произвести эвакуацию
            $this->http->get("http://{$this->ud['uniUrl']}/game/index.php?page=fleet1&session={$this->sessionCode}&cp=$cp");
            //ресурсы и флоты парсим
            $planetName = $this->getResInfo($this->http->data());
            $planetName2 = $this->getFleetInfo($this->http->data());
            //если данные прочтены верно (ф-ция вернет имя планеты)
            if ($planetName == $planetName2 && $planetName !== false) {
                //выбор планеты назначения
                if (is_array($this->ud['planets'][$planetName]['refugeVars'])) {
                    $tn = $this->ud['planets'][$planetName]['refugeVars'];
                    $refPlanet = 'refplanet_' . $tn['to'];
                    $this->planets[$refPlanet] = array($tn['to']);
                    $dst = $this->distance($this->planets[$planetName][0], $this->planets[$refPlanet][0]);
                    $mission = $tn['mission'];// транспорт обычно (код 3)
                    
                } else {
                
                    $dst = 100000000;
                    $refPlanet = '';
                    $mission = 4;// оставить
                    
                    foreach ($this->planets as $k => $v) {
                        if ($k == $planetName) continue;
                        $newdst = $this->distance($this->planets[$planetName][0], $this->planets[$k][0]);
                        if ($newdst < $dst) {
                            $refPlanet = $k;
                            $dst = $newdst;
                        }
                    }
                }
                echo "\n************Evacuation CALCULATIONS*************\nDst refuge planet: $refPlanet, distance: $dst";
                //спасаемый флот
                $refFleet = $this->planets[$planetName]['fleet'];
                $refRes =   $this->planets[$planetName]['res'];
                
                echo "\nFleets <pre>";
                print_r($refFleet);
                echo "</pre>\nResources <pre>";
                print_r($refRes);
                echo "</pre>\n";
                
                //планету, куда лететь выбрали
                if ($refPlanet && !empty($refFleet)) {
                    //расчет топлива (хватит ли и сколько груза брать...)
                    $fuelCons = $this->consumption($refFleet, 1, $dst);
                    $attempts = 20;
                    while ($attempts-- >= 0 && $fuelCons > $refRes['deuterium']) {
                        //что делать, если топлива не хватает?
                        //нужно последовательно уменьшать флот, чтобы снизить потребление топлива (по 5% бум уменьшать чтобы итераций было не так много)
                        foreach ($refFleet as $k => $v) $refFleet[$k] = floor($v * 0.95);
                        $fuelCons = $this->consumption($refFleet, 1, $dst);
                    }
                    echo "\nFuelConsumption: $fuelCons";
                    echo "\nFleets to start<pre>";
                    print_r($refFleet);
                    echo "</pre>\n";
                    
                    //если число попыток не кончилось...
                    if ($attempts >= 0) {
                        //сумма грузового отсека
                        $freeCargo = $this->calcFreeCargo($refFleet) - $fuelCons;
                        //общая сумма ресурсов
                        $sumRes = $refRes['deuterium'] + $refRes['crystal'] + $refRes['metal'];

                        //выбор груза
                        if ($sumRes > $freeCargo) {
                            //сначала дейтерий
                            $dtr = $refRes['deuterium'] - $fuelCons;
                            if ($dtr >= $freeCargo) {
                                $dtr = $freeCargo;
                                $restCargo = 0;
                            } else {
                                $restCargo = $freeCargo - $dtr;
                            }
                            //далее важен кристалл
                            $cry = $refRes['crystal'];
                            if ($cry >= $restCargo) {
                                $cry = $restCargo;
                                $restCargo = 0;
                            } else {
                                $restCargo -= $cry;
                            }
                            //далее - металл
                            $met = $refRes['metal'];
                            if ($met >= $restCargo) {
                                $met = $restCargo;
                            }
                        } else {
                            $dtr = $refRes['deuterium'];
                            $cry = $refRes['crystal'];
                            $met = $refRes['metal'];
                        }                    
                        //выполним отправку выбранного флота
                        echo "\nfleet order params:<pre>";
                        print_r(
                            array(
                                $this->planets[$planetName][0], 
                                $this->planets[$refPlanet][0],
                                $refFleet, 
                                array('speed' => 1, 'metal' => $met, 'crystal' => $cry, 'deuterium' => $dtr)));
                                
                        $this->fleet_order($this->planets[$planetName][0], $this->planets[$refPlanet][0], $refFleet, 
                            array('speed' => 1, 'mission' => $mission, 'metal' => $met, 'crystal' => $cry, 'deuterium' => $dtr)
                        );
                        //теперь надо запомнить код флота и связать его с кодом маршрута атаки
                        $fleets = $this->getFleets($this->http->data());
                        foreach($fleets as $v) {
                            if (empty($v['id'])) continue;
                            if ($v['fromPlanet'] == $planetName && $v['toPlanetCoords'] == $this->planets[$refPlanet][0]
                                && $this->equalFleets($v['ships'], $refFleet)) {
                                return array(
                                    //код отправленного флота нужен чтобы сохранить в базе
                                    'id' => $v['id'],
                                    'timeStart' => $this->currentTime,
                                    'from' => $planetName, //от куда взлетаем
                                    'to' => $refPlanet //куда спасаемся
                                );
                            }
                        }
                    }
                } else {
                    echo '\nEvac error: can`t select destination planet or no fleet on the planet!';
                }
            }
        }
        return false;
    }
    
    //проверяет равны ли флоты
    function equalFleets($fl1, $fl2) {
        foreach($fl1 as $k => $v) {
            if ($fl2[$k] == $v) $fl2[$k] = 0;
        }
        foreach($fl2 as $k => $v) {
            if ($v > 0) return false;
        }
        return true;
    }

    function fleetCommander($ud, $auth) {
        $this->ud = $ud;       
        $st = new settings();
        $this->oas = $st->S;
        
        if ($auth && $this->oas['guardmode']) {
            $this->http = new s_http();
            $this->http->init();
            $this->ready = $this->auth();
        } else 
            $this->ready = false; //режим охраны не включен
    }
    
    function setOGV($name, $value) {
        $this->oas[$name] = $value;
    }
    
    function abortMission($fleetRefuge) {
        $this->http->get("http://{$this->ud['uniUrl']}/game/index.php?page=movement&session={$this->sessionCode}&return=$fleetRefuge");
    }
    
    function selectedPlanet($data) {
        $s = new Searcher();
        $s->init($data);    
        //надо понять для какой планеты мы прочитали эти данные
        if (!$s->cursorTo('id="myWorlds"')) return false;
            
        while ($s->cursorTo('<div class="smallplanet">')) {
            $s->setRangeEnd('</div>');
            $name = $s->readBeforeRange('class="planet-name">', '</span>');
            $isit = $s->isInRange(' active ');
            if ($isit) break;
        }
        return $name; //вернем имя планеты для которой прочитали ресурс    
    }
    
    //считывание данных о ресурсах
    //сохраняем эти данные в массив planets
    //если чтение данных не возможно - false
    //иначе вернем имя планеты
    function getResInfo($data) {
        $s = new Searcher();
        $s->init($data);
        
        if (!$s->cursorTo('id="metal_box"')) return false;
        
        $s->cursorTo('<span id="resources_metal"');
        $s->setRangeEnd('/span>');
        $metal = intval(str_replace('.', '', $s->readBeforeRange('>', '<')));

        $s->cursorTo('<span id="resources_crystal"');
        $s->setRangeEnd('/span>');
        $cryst = intval(str_replace('.', '', $s->readBeforeRange('>', '<')));

        $s->cursorTo('<span id="resources_deuterium"');
        $s->setRangeEnd('/span>');
        $deyt = intval(str_replace('.', '', $s->readBeforeRange('>', '<')));

        $name = $this->selectedPlanet($data);

        if ($name !== false) {
            $this->planets[$name]['res'] = array(
                'metal' => $metal,
                'crystal' => $cryst,
                'deuterium' => $deyt,
            );
            return $name; //вернем имя планеты для которой прочитали ресурсы            
        }
        
        return false;
        
    }
    
    //считывание данных о флотах
    //сохраняем эти данные в массив planets
    //если чтение данных не возможно - false
    //иначе вернем имя планеты
    function getFleetInfo($data) {
        $s = new Searcher();
        $s->init($data);
        
        if (!$s->cursorTo('<ul id="military">')) return false;
        $name = $this->selectedPlanet($data);
        if ($name === false) return false;
        
        if (preg_match_all('#checkIntInput[(]"ship\_([\d]+)", [\d]+, ([\d]+)[)]#', $data, $m)) {
            $this->planets[$name]['fleet'] = array();
            foreach($m[0] as $k => $v) {
                foreach ($this->dict as $dk => $dv) {
                    if ('am' . $m[1][$k] == $dv[0])
                        $this->planets[$name]['fleet'][$dk] = $m[2][$k];
                }
            }
        }
        return $name; //вернем имя планеты для которой прочитали флот    
    }
    
    function auth() {
        if ($this->http->get('http://ogame.ru')) {
            $this->http->post('http://'. $this->ud['uniUrl'] . '/game/reg/login2.php', "uni_id=&v=2&is_utf8=0&uni_url={$this->ud['uniUrl']}&login={$this->ud['login']}&pass={$this->ud['password']}");

            //чтение списка планет, определение тех, что атакуются в текущий момент
            $s = new Searcher();
            $s->init($this->http->data());

            $s->cursorTo('<body');
            $s->rangeEnd = strlen($s->data) - 1;
            
            $this->planets = array();
            $this->isAlert = false;
            
            $this->sessionCode = $s->readBeforeRange('&session=', '"');
            $this->currentTime = strtotime(strip_tags($s->readBeforeRange('<div id="OGameClock">', '</div>')));
            
            if (empty($this->sessionCode) || empty($this->sessionCode)) {
                echo "Can't read sessionCode or currentTime !\n";
                return false;
            }
            
            $s->cursorTo('id="myWorlds"');
            
            while ($s->cursorTo('<div class="smallplanet">')) {
                $s->setRangeEnd('</div>');
                $name = $s->readBeforeRange('class="planet-name">', '</span>');
                $koords = $s->readBeforeRange('class="planet-koords">[', ']</span>');
                $alert = $s->isInRange('<a class="alert ');
                $this->isAlert = $this->isAlert || $alert;
                if ($name && $koords)
                    $this->planets[$name] = array($koords, $alert);
            }
            
            if (empty($this->planets)) return false;
            return true;
        }
        return false;
    }

    //приказ флоту
    //what вида array('ЛИ' => 1, ...)
    function fleet_order($from, $to, $what, $how) {
        $cp = $this->getCPbyKoords($from);
        if (!cp) {
            echo "Can't drive this planet! Planet code is unknown!";
            return false;
        }
        //переводим имена кораблей в коды формы

        $fleetUri = '';
        foreach ($what as $k => $v) {
            if (!empty($this->dict[$k])) $fleetUri .= '&' . $this->dict[$k][0] . '=' . $v;
        }
        //чтение доп. паратеров
        //какая миссия?
        if (isset($how['mission'])) $mission = $how['mission']; else $mission = 4; /* по умолчанию - миссия оставить */
        //какая скорость?
        if (isset($how['speed'])) $speed = $how['speed']; else $speed = 10; /* по умолчанию скорость максимальная  */
        //загрузка ресурсов
        if (isset($how['metal'])) $metal = $how['metal']; else $metal = 0; /* по умолчанию металл не грузим */
        if (isset($how['crystal'])) $crystal = $how['crystal']; else $crystal = 0; /* по умолчанию кристал не грузим */
        if (isset($how['deuterium'])) $deuterium = $how['deuterium']; else $deuterium = 0; /* по умолчанию дейтерий не грузим */        
        
        //переход на планету отправки флота ($from)
        $this->http->get("http://{$this->ud['uniUrl']}/game/index.php?page=fleet1&session={$this->sessionCode}&cp=$cp");
//        echo $this->http->data();
        echo "\n--------------------------------------------------\n";
        //первая страница - выбор флота
        $m = explode(':', $from);
        $uriKoords = "galaxy=$m[0]&system=$m[1]&position=$m[2]";
        $this->http->post($q= "http://{$this->ud['uniUrl']}/game/index.php?page=fleet2&session={$this->sessionCode}",
            $post = "$uriKoords&type=1&mission=0&speed=10{$fleetUri}");
        echo "\n $q : $post";
//        echo $this->http->data();
        echo "\n--------------------------------------------------\n";
        //выбор куда летим
        $m = explode(':', $to);
        $this->http->post($q = "http://{$this->ud['uniUrl']}/game/index.php?page=fleetcheck&session={$this->sessionCode}&ajax=1&espionage=",
            $post = "galaxy=$m[0]&system=$m[1]&planet=$m[2]&type=1");
        echo "\n $q : $post";
        $uriKoords2 = "galaxy=$m[0]&system=$m[1]&position=$m[2]";
        $this->http->post($q = "http://{$this->ud['uniUrl']}/game/index.php?page=fleet3&session={$this->sessionCode}",
            $post = "type=1&mission=0&union=0{$fleetUri}&{$uriKoords2}&speed={$speed}");
        echo "\n $q : $post";
//        echo $this->http->data();
        echo "\n--------------------------------------------------\n";
        //на старт!
        //transport - 3
        //оставить - 4
        $this->http->post($q = "http://{$this->ud['uniUrl']}/game/index.php?page=movement&session={$this->sessionCode}",
            $post = "holdingtime=1&expeditiontime=1&{$uriKoords2}&type=1&mission={$mission}&union2=0&holdingOrExpTime=0&speed={$speed}{$fleetUri}&metal=$metal&crystal=$crystal&deuterium=$deuterium"
        );
        echo "\n $q : $post";
//        echo $this->http->data();
    }    

    // чтение данных о движении собственных флотов
    function getFleets($data = null) {
        if (!$data) {
            $this->http->get("http://{$this->ud['uniUrl']}/game/index.php?page=movement&session={$this->sessionCode}");
            $data = $this->http->data();
        }
        
        $s = new Searcher();
        $s->init($data);
        $fleets = array();
        
        while ($s->cursorTo('class="fleetDetails')) {
            $s->setRangeEnd(array('class="fleetDetails', '<div id="rechts">'));
            $fleet = array();
            
            $fleet['fromPlanetCoords'] = $s->getByPatternFromRange(
                'class="originCoords', '</span>', '$\[([\d]+[:][\d]+[:][\d]+)\]$');
            $fleet['fromPlanet'] =   trim($s->readBeforeRange('<span class="originPlanet">', '</span>'));
            $fleet['toPlanetCoords'] = $s->getByPatternFromRange(
                'class="destinationCoords', '</span>', '$\[([\d]+[:][\d]+[:][\d]+)\]$');
            $fleet['toPlanet'] =     trim($s->readBeforeRange('<span class="destinationPlanet">', '</span>'));
            if (preg_match('@href="index.php[?]page=movement[&]session=[\d\w]+[&]return=([\d]+)">@', $s->copyRange(), $m)) {
                $fleet['id'] = $m[1];
            }
            //сбор информации о флоте
            $fleet['ships'] = array();
            $s->cursorTo('class="fleetinfo"');
            $s->setRangeEnd('</table>');
            while($s->pos < $s->rangeEnd) {
                $ShipTypeName = trim($s->readBeforeRange('<td>', '</td>'));
                $value = trim($s->readBeforeRange('<td class="value">', '</td>'));
                $s->cursorTo('<td class="value">');
                if ($ShipTypeName == 'Металл:') break;
                $shCode = $this -> getShipCode($ShipTypeName);
                if ($shCode) {
                    $fleet['ships'][$shCode] = $value;
                }
            }
            
            $fleets[] = $fleet;
        }
        return $fleets;
    }    
    
    /* поиск кода корабля по его наименованию */ 
    function getShipCode($name) {
        foreach($this->dict as $k => $v) 
            if ($v[4] == $name) return $k;
        return false;
    }
    
    //запрос данных по маршрутам    
    function getRouts() {
        $this->http->get("http://{$this->ud['uniUrl']}/game/index.php?page=eventList&session={$this->sessionCode}");
        $s = new Searcher();
        $s->init($this->http->data());
        $routs = array();
        while ($s->cursorTo('<div class="eventFleet"')) {
            $s->setRangeEnd(array('<div class="eventFleet"', '<div id="eventFooter">'));
            $rout = array();
            $rout['id'] =           $s->readBeforeRange('id="eventRow-', '">');
            $rout['aTime'] =        substr($s->readBeforeRange('class="arrivalTime">', '</li>'), 0, 8);
            if ($rout['aTime'] === false) continue; //при детализации совместных аттак не известно например время прибытия - оно как бы общее в
            if ($rout['aTime'] < date('H:i:s', $this->currentTime)) 
                //т.е. атака состоится в следующие сутки
                $rout['aTime'] = strtotime(date('d.m.Y ', $this->currentTime + 84600) . $rout['aTime']);
            else 
                //иначе состоится в эти же сутки
                $rout['aTime'] = strtotime(date('d.m.Y ', $this->currentTime) . $rout['aTime']);
            
            $rout['descr'] =        trim(strip_tags($s->readBeforeRange('class="descFleet">', '</li>')));
            //Чужой флот, Собственный флот
            $rout['mission'] =      strip_tags($s->readBeforeRange('class="missionFleet">', '</li>'));
            //Атака, Переработать, Экспедиция , Транспорт, Совместная атака 
            $rout['fromWhere'] =    substr(strip_tags($s->readBeforeRange('class="coordsOrigin">', '</li>')), 1, -1);
            $rout['toWhere'] =      substr(strip_tags($s->readBeforeRange('class="destCoords">', '</li>')), 1, -1);
            $rout['toWherePlanet']= trim($s->readBeforeRange('class="destFleet">', '</li>'));
            $routs[$rout['id']] = $rout;

        }
        return $routs;
    }
    
    // запрос страницы из галактического вьювера (стоит 10 дейтерия)
    function getGalaxyPage($koords) {
        $t = explode(':', $koords);
        
        $this->http->post("http://{$this->ud['uniUrl']}/game/index.php?page=galaxyCanLoad&session={$this->sessionCode}&ajax=1",
            "galaxy=$t[0]&system=$t[1]");
        $this->http->post("http://{$this->ud['uniUrl']}/game/index.php?page=galaxyContent&session={$this->sessionCode}&ajax=1",
            "galaxy=$t[0]&system=$t[1]");
        //парсим планеты
        $s = new Searcher();
        $s->init($this->http->data());
        if (!$s->cursorTo('id="galaxyheadbg2"')) return false;
        
        $map = array();
        
        while ($s->cursorTo('<tr class="row">')) {
            $s->setRangeEnd('</tr>');
            $planet = array();
            $planet['koords']       = substr($s->readBeforeRange('<span id="pos-planet">', '</span>'), 1, -1);
            $planet['name']         = trim(strip_tags($s->readBeforeRange('<td class="planetname">', '</td>')));
            if (($planet['player'] = trim($s->readBeforeRange('<span class="status_abbr_active">', '</span>')))
                || ($planet['player'] = trim($s->readBeforeRange('<span class="status_abbr_noob">', '</span>')))
                || ($planet['player'] = trim($s->readBeforeRange('<span class="status_abbr_vacation">', '</span>')))
                || ($planet['player'] = trim($s->readBeforeRange('<span class="status_abbr_banned">', '</span>')))
                );
            
            $planet['haveMoon']     = $s->isInRange('id="pos-moon"');
            $planet['messageLink']  = $s->readBeforeRange('index.php?page=writemessage&', '"');
            if (!empty($planet['messageLink'])) 
                $planet['messageLink'] = "http://{$this->ud['uniUrl']}/game/index.php?page=writemessage&" . $planet['messageLink'];

            $map[$planet['koords']] = $planet;
        }
        
        return $map;
    }
    
    /* возвращает код планеты, $koords - имя или координаты планеты */
    function getCPbyKoords($koords) {
        foreach ($this->ud['planets'] as $k => $v) {
            if ($v[0] == $koords || $k == $koords) return $v[1];
        }
        return false;
    }
    
    /* возвращает имя планеты - $koords - координаты планеты */
    function getNamebyKoords($koords) {
        foreach ($this->ud['planets'] as $k => $v) 
            if ($v[0] == $koords) return $k;
        return false;
    }    
}